package com.opencms.modules.listes;


import com.opencms.file.*;
import com.opencms.core.*;
import com.opencms.util.*;
import com.opencms.template.*;
import com.opencms.workplace.*;
import com.opencms.defaults.*;

import java.util.*;
import java.io.*;
import java.sql.*;
import java.text.*;




public class EnvoiListeDiffusion {


	/* stockage des adresses mails dans un vecteur */
	Vector vEmails ;
	/* et dans un tableau de String... */
	String[] tabEmails;

	/* rcupration des champs de l'instance cree */
	int m_id;
	String m_sujet;
	String strDate;
	String m_message;	
	String strChannel;
	

	/* constructeur sans parametre */
	public EnvoiListeDiffusion() {
		vEmails = new Vector();
		tabEmails = null;
		
		m_id = 0;
		m_sujet = new String();
		strDate = new String();
		m_message = new String();
		strChannel = new String();
	}

	public void traiteListesDiffusion () {
		
		
		Vector vThreads = listesThreadsContentDefinition.getThreadsByStatus(0);
		
		try {
			com.opencms.modules.listes.Utils.log("Envois en cours : "+vThreads.size() );
		} catch (FileNotFoundException fnfe) {}	
		
		for (int i=0; i< vThreads.size(); i++ ) {
			// rcupration de l'objet de type : 'listesThreadsContentDefinition' associ
			listesThreadsContentDefinition lTCD = (listesThreadsContentDefinition)vThreads.elementAt(i);
			m_id = lTCD.getIntId();
			
			/* 
 		    * bloquage de toutes les listes de diffusion concernes :
			* => mise en statut '1' de tous les objets listesThreadsContentDefinition
			*	(sont concernes ceux qui etaient en statut '0')
			*/
			
			try {
				com.opencms.modules.listes.Utils.log("Mise a jour en statut 1 pour l'envoi n : "+i);
			}
			catch (FileNotFoundException fnfe) {}			
			
			lTCD.setEtat(1);
			try {
				lTCD.updateEtat(m_id, 1);
			}
			catch (CmsException e) {
				
			}
			traiteMails(lTCD);
			
		}
	} // end method traiteListesDiffusion()


	/* routine  proprement parler de traitement de mails 
	* - rcupration des objets listesThreadsContentDefinition : 
	* - chacun de ces objets est mis en statut 1 (en cours d'envoi
	* - traitement a partir des donnes rcupres
	* 	- sujet du mail
	*	- corps du mail
	*	- date du mail
	*/
	
	public void traiteMails (listesThreadsContentDefinition lTCD) {

			
		/* rcupration des champs de l'instance cre */
		m_sujet = lTCD.getSujet();
		strDate = lTCD.getDate();
		m_message = lTCD.getCompleteMessage();
		strChannel = lTCD.getStrChannel();
	
	
		/* instance de l'objet 'listesChannelContentDefinition' associ */
		listesChannelContentDefinition channel = lTCD.getChannelObject();				
		
		/* on remonte jusqu'a la la liste de diffusion */
		int channel_id = channel.getIntId();
		Integer channel_id_Int = new Integer(channel_id);
		
		int ii = -1;
		
		String moinsUn = String.valueOf(ii);
		
		Vector v_abo = listesAboContentDefinition.getList(channel_id_Int, moinsUn);

		tabEmails = new String[v_abo.size()];
		 // rcupration d'objets de type :listesAboContentDefinition
		 for (int j=0; j<v_abo.size(); j++) {

		 	listesAboContentDefinition abonne = (listesAboContentDefinition)v_abo.elementAt(j);
		 	String abo_email = abonne.getEmail();
		 	String abo_nom = abonne.getNom();
			
			vEmails.addElement(abo_email);
			tabEmails[j] = abo_email;
		 }
		 
		 sendToList(lTCD);

	} // end method traiteMails()


	public void sendToList (listesThreadsContentDefinition lTCD) {

		String from = "";
		String hote = "";

		boolean debug = false;

		String[] tabEmailsNonBlacklistes; 

		/* controle sur la blacklist
		* ( test effectue uniquement si la blacklist est non vide...)
		*/
			
		
		if (com.opencms.modules.listes.I_BlackList.BLACKLIST.length >0 ){
			Hashtable ht = com.opencms.modules.listes.Utils.checkBlackListed(tabEmails);
	
			Vector vDestinataires = new Vector();
			for (int i=0; i<ht.size(); i++) {
				// on reconstitue la liste :
				
				String autorise = (String)ht.get(tabEmails[i]);
				if ( autorise.equals("true") ) {
					vDestinataires.addElement(tabEmails[i]);
				}
				else {
					try {			
						com.opencms.modules.listes.Utils.log("L'email : "+tabEmails[i]+" appartient a la blacklist. Il ne recevra pas le message.");
					} catch (FileNotFoundException fnfe) {}	
				}
			}
			
			String[] to_accepte = new String[vDestinataires.size()];
			for (int j=0; j<vDestinataires.size(); j++) {
				to_accepte[j] = (String)vDestinataires.elementAt(j);
			}
			tabEmailsNonBlacklistes = to_accepte;
		}
			
		/* cas o la blacklist est vide
		*/
		else {
			tabEmailsNonBlacklistes = tabEmails;
		}

		// decoupage de la liste d'emails en paquets d'emails...
		int tabSize = com.opencms.modules.listes.Utils.getNbPaquetsEmail();

		ThreadEnvoi threadEnvoi = new ThreadEnvoi(m_id, tabEmailsNonBlacklistes, from, m_sujet, m_message, debug, hote, tabSize,lTCD);
		// envoi de paquets de mail

		String res = threadEnvoi.launchMails_FOR();
		threadEnvoi.majRapport(res);
		
	} // end method sendToList



} // end class EnvoiListeDiffusion




// exemple de code pour l'envoi de piece attachee...

/*******************************************************************	
// Cas d'envoi de piece attachee (HORS THREAD)

// String fichier = "c:/envoi1.html";		
// le chemin donne pour le fichier est-il correct ?
if ( Envoi.checkAttachedFilePath(fichier) > 0 ) {
	// mauvais chemin de fichier : mail envoye sans piece attachee
	envoi = new Envoi(to, from, sujet, corps, debug);
}
else {
	// piece jointe
	envoi = new Envoi (to, from, sujet, corps, fichier, debug);
}
********************************************************************/




		
		
