package com.opencms.modules.listes;

import java.util.Vector;
import java.io.*;

import com.opencms.core.*;



// public class ThreadEnvoi implements I_CheckMails {
public class ThreadEnvoi {
	
	int m_id;
	String[] tabEmailsNonBlacklistes;
	String from;
	String m_sujet;
	String m_message;
	boolean debug;

	String hote;	
	int tabSize;

	listesThreadsContentDefinition lTCD;
	
	Vector vEnvoi;	
	
	// resultat de l'envoi de tous les paquets correspondant a un message
	boolean all_envoi_error_smtp;
	boolean all_envoi_error_send;

	// la mise  jour en statut '2', ou '3', n'est effectuee QUE si tous les mails ont ete traites
	// (si coupure internet, le statut reste a '1')
	boolean all_emails_sent;	
	
	public ThreadEnvoi (int m_id, String[] tabEmailsNonBlacklistes, String from, String m_sujet, String m_message, boolean debug, String hote, int tabSize, listesThreadsContentDefinition lTCD) {

		this.m_id = m_id;	
		this.tabEmailsNonBlacklistes = tabEmailsNonBlacklistes;
		this.from = from;
		this.m_sujet = m_sujet;
		this.m_message = m_message;
		this.debug = debug;
		this.hote = hote;
		this.tabSize = tabSize;
		
		this.lTCD = lTCD;		
		
		
		this.vEnvoi = Utils.splitTableau(tabEmailsNonBlacklistes, tabSize);

		this.all_envoi_error_smtp = false;
		this.all_envoi_error_send = false;
		this.all_emails_sent = false;
	}	

	/* lancement des envois de mails par paquets avec des Threads
	*/
	public void launchMails_Threads() {
	}
	/* lancement des envois de mails par paquets avec une boucle 'for'
	*/	
	public String launchMails_FOR() {
		int nb = 0;
		String rap = new String();

		for (int i=0; i<vEnvoi.size(); i++) {		
			String[] tabPartiel = new String[this.tabSize];
			
			tabPartiel = (String[])vEnvoi.elementAt(i); 

			try  {
				com.opencms.modules.listes.Utils.log("Lancement du paquet de message n : "+ i);
			} catch (FileNotFoundException fnfe) {}				
			
			
			// lancement des Threads...
			Envoi envoi = new Envoi(m_id, tabPartiel, from, m_sujet, m_message, debug, hote);
			
			envoi.send();
			
			// recuperation des diverses erreurs survenues lors de l'envoi
			if (envoi.is_error_send) {
				String r = envoi.rapport;
				// System.out.println("Rapport d'envoi : " + r + "\n\n");
				rap = rap + r;
				all_envoi_error_send = true;
			}	
			if (envoi.is_error_smtp) {			
				all_envoi_error_smtp = true;		
			}
			nb++;			

 		} // end for

		if (nb == vEnvoi.size() ) {
			all_emails_sent = true;
		}

		return rap;
	} // end method launchThread



	public void majRapport (String rapport) {

		// Mise a jour du rapport d'envoi
				
		if (all_envoi_error_smtp) {
			
			try  {	
				com.opencms.modules.listes.Utils.log("Message mis en statut 3...\n");
			} catch (FileNotFoundException fnfe) {}	
			
			// mise a jour du statut :
			// 	=> mise en statut '3' : probleme d'envoi
			if (all_emails_sent)
				lTCD.setEtat(3);
			
			try {
				lTCD.updateEtat(m_id, 3);
			}
			catch (CmsException e) {}
			
			// renseignement du champ rapport
			// mise  jour du rapport d'envoi :
			//
			lTCD.setRapport(rapport);
			try {
				lTCD.updateRapport(m_id, rapport);
			}
			catch (CmsException e) {}
			
		}
		else if (all_envoi_error_send) {
			
			try {
				com.opencms.modules.listes.Utils.log("Message mis en statut 2...\n");
			} catch (FileNotFoundException fnfe) {}				
			if (all_emails_sent)
				lTCD.setEtat(2);
			
			try {
				lTCD.updateEtat(m_id, 2);
			}
			catch (CmsException e) {}
			
			lTCD.setRapport(rapport);
			try {
				lTCD.updateRapport(m_id, rapport);
			}
			catch (CmsException e) {}
		}
		
		// pas de problemes avec les adresses mail => pas de rapport
		else {
			
			try {
				com.opencms.modules.listes.Utils.log("Message mis en statut 2...\n");
			} catch (FileNotFoundException fnfe) {}				
			
			if (all_emails_sent)
				lTCD.setEtat(2);
		
			try {
				lTCD.updateEtat(m_id, 2);
			}
			catch (CmsException e) {}
		}

	} // end method majRapport
	
} 