package com.opencms.modules.listes;

import java.util.*;
import java.io.*;

import javax.mail.Session;
import javax.naming.Context;
import javax.naming.InitialContext;

import javax.mail.internet.*;
import javax.activation.*;
import javax.mail.*;
import javax.mail.internet.*;

import com.opencms.core.A_OpenCms;
import com.opencms.core.CmsException;
import com.opencms.core.OpenCms;
import com.opencms.file.CmsObject;


/**
 *
 * Classe o sont consignes des mthodes gnriques, hors scopes...
 */

public class Utils implements I_BlackList {



	public static final int FILE_OK = 0;
	public static final int ERR_FILE_ISNOTFILE = 1;
	public static final int ERR_FILE_ISDIR = 2;
	public static final int ERR_FILE_HAS_FORBIDDEN_EXTENSION = 3;

	public static String TAILLE_TABLEAU;
	public static String MAIL_FROM;
	public static String LOG_FILE;




 	/* This code is executed on load-time of this class : SI CHANGEMENT DES PARAMETRES DEFINIS DANS LE MODULE */
  	static {
	try {
  			// set the pool
  			moduleParameterWasUpdated(null);
			A_OpenCms.log("opencms_info", "Utils.static :: rcupration des paramtres du module...");

		} catch(CmsException  exc) {
  			// TODO: Error-handling
		}
  	}


  	/**
   	* This event-method is invoked if a user changes a parameter for a module in the module-
   	* administration.
   	* It reads the current name of the pool for this module and stores it to c_pool
   	* @param CmsObject - the cmsobject to get access to the cms.
   	*/
  	public static void moduleParameterWasUpdated(CmsObject cms) throws CmsException {

		TAILLE_TABLEAU = OpenCms.getRegistry().getModuleParameterString("com.opencms.modules.listes", "TAILLE_TABLEAU");
		MAIL_FROM = OpenCms.getRegistry().getModuleParameterString("com.opencms.modules.listes", "MAIL_FROM");
		LOG_FILE = OpenCms.getRegistry().getModuleParameterString("com.opencms.modules.listes", "LOG_FILE");

		A_OpenCms.log("opencms_info", "Utils.moduleParameterWasUpdated :: TAILLE_TABLEAU : "+TAILLE_TABLEAU+ " - MAIL_FROM : "+MAIL_FROM+ " - LOG_FILE : "+LOG_FILE);
  	}


	public static int getNbPaquetsEmail () {
		// taille des paquets de mails
		int tabSize;
		tabSize = (new Integer(TAILLE_TABLEAU).intValue() );

		return tabSize;		
	}


 	public static String getMAIL_FROM () {
		return MAIL_FROM;
	}


 	public static String getLogFile () {
		return LOG_FILE;
	}
		

	/*
	* Test pour l'ajout de piece(s) attachee(s) :
	*	- la chaine passe en parartre correspond bien  un chemin de fichier
	* 	- le type de ce fichier est un type autoris (ne pas autoriser l'envoi de .vbs, par exemple...
	*	- inscrire dans le log une trace de cet envoi de fichier (ou tout du moins la tentative d'envoi)
	* 
	* La valeur entire retourne par la routine donne le code d'erreur
	*/
	public static int checkAttachedFilePath (String strPath) {
		File f = new File (strPath);
		if (! f.exists()) {
			return ERR_FILE_ISNOTFILE;	
		}
		else if ( f.isDirectory() ) {
			return ERR_FILE_ISDIR;
		}
	
		else if ( f.getPath().endsWith(".vbs") || f.getPath().endsWith(".ini")  )	{
			/* extension du fichier non tolre...
			* la liste des extensions interdites sera consigne dans un tableau de chaines de l'interface I_Checkmails
			*/
			return ERR_FILE_HAS_FORBIDDEN_EXTENSION;
		}
		else 	
			return 0;
	
	}


	/* routine d'ecriture dans le log
	* 	- date
	*	- message
	*/
	public static void log (String message) throws FileNotFoundException {

		Calendar gCalendar = Calendar.getInstance();	
		
		int year = gCalendar.get(Calendar.YEAR);
		int month = gCalendar.get(Calendar.MONTH);

		// le mois de janvier est le mois 0
		month = month + 1;

		int day_of_month = gCalendar.get(Calendar.DAY_OF_MONTH);				
		int hour = gCalendar.get(Calendar.HOUR);		
		int minute = gCalendar.get(Calendar.MINUTE);
		int second = gCalendar.get(Calendar.SECOND);
		int am_pm = gCalendar.get(Calendar.AM_PM);					
		
		String strAm_Pm = new String();
		if (am_pm==0) {
			strAm_Pm = "AM";
		}
		else {
			if (am_pm==1) {
				strAm_Pm = "PM";
			}
		}
		
		String strDate = year+"/"+month+"/"+day_of_month+"::"+strAm_Pm+" "+hour+"h"+minute+"min"+second+"s"; 
	
		
		try {
			String trace = new String();
			
			trace = strDate  +" ";
			trace += "\t : " + message + "\n";
			
			String logFilePath = Utils.getLogFile();
			File logFile = new File(logFilePath); 
			RandomAccessFile fd = new RandomAccessFile(logFile, "rw");

			byte[] b = trace.getBytes();
			
			try {
				fd.seek(fd.length());
				fd.write(b);
				fd.close();
			}
			catch (IOException ioe) {
				// System.out.println("erreur globale ecriture dans le fichier log_email");
			}
		 }
		 catch (FileNotFoundException fnfe){}
	}


	/* les envois de mails sont tracs :
	* 	- date
	* 	- expditeur
	* 	- destinataires
	* 	- succs ou non de l'opration
	*	- ventuelles erreurs
	*/
	public static void log_mail (Envoi envoi, String message, int erreur_code) throws FileNotFoundException {
		// A NOTER QUE TOUTE LA PARTIE GESTION DE FICHIER DOIT ETRE REMONTEE ET SORTIE D'ICI
		
		try {
			String trace = new String();
			
			trace = "Exp : " + envoi.from + "\n";
			trace += "\tMessage : " + message + "\n\n";
			
			String logFilePath = Utils.getLogFile();
			File logFile = new File(logFilePath); 
			RandomAccessFile fd = new RandomAccessFile(logFile, "rw");

			byte[] b = trace.getBytes();
			
			try {
				fd.seek(fd.length());
				fd.write(b);
				fd.close();
			}
			catch (IOException ioe) {
				// System.out.println("erreur globale ecriture dans le fichier log_email");
			}
		 }
		 catch (FileNotFoundException fnfe){}
	}

	/*
	* Contrles effectus sur la blacklist
	* @in String : adresse mail teste
	* out boolean : blackliste ou non
	*/
	public static boolean CheckBlackListed (String mailto) {
		/* controle sur une personne */
		boolean b = true;
		for (int i=0; i<BLACKLIST.length; i++){
			if ( mailto.equals(BLACKLIST[i]) )
				b =false;
		}
		return b;
	}

	/*
	* controle sur une liste de personnes :
	* @in String[] : liste des adresses controles
	* @out Enumeration : chacune des adresses testes est associe  un boolen : autorise ou non
	*/
	public static Hashtable checkBlackListed (String[] tabMailto) {
		Hashtable hTable = new Hashtable();
		for (int i=0; i<tabMailto.length; i++) {
			boolean b;

			// adresse valide ?
			b = CheckBlackListed(tabMailto[i]);
			String strb = String.valueOf(b);
			hTable.put(tabMailto[i], strb);
		}
		return hTable;
	}


	/*
	* split de l'adresse email : acolin@7p4.fr => {acolin, 7p4, fr}
 	* @in String : email
	* @out String[] : tableau de trois string
	*/
	public static String[] splitEmail (String email) throws ArrayIndexOutOfBoundsException {
		String[] tabRes = new String[3];

		String[] tabInterm = new String[2];
		String[] tabInterm2 = new String[2];
	
		for (int i=0; i<3; i++) {
			tabRes[i]="";
		}
	
		try {
			// il faut vrifier que l'adresse teste comprend bien les caratres selon lesquels on 'dcoupe' : '@' , '.'
			tabInterm = email.split("@");

			int t1 = tabInterm[1].length();

			int dernIndex = tabInterm[1].lastIndexOf(".");

			String domain_email = tabInterm[1].substring(dernIndex);			
			String suffix_email = tabInterm[1].substring(0, dernIndex);
			
			tabRes[0] = tabInterm[0];
			tabRes[1] = domain_email;
			tabRes[2] = suffix_email;			
		}
		catch (ArrayIndexOutOfBoundsException aoobe) {
			// les caractres requis de l'adresse email n'ont pas t trouvs ('@','.',...)
		}
		return tabRes;
	}
	
	

	/*
	 * 
	 *  Routine de decoupage de tableau en tableaux plus petits
	 */
	 
	public static Vector splitTableau (String[] tabEmails, int tabSize) {
			
		Vector vTab = new Vector();
		
		int t = tabEmails.length;
		int tDiv10 = (new Double(t/tabSize)).intValue();
		int reste = t - tabSize*tDiv10;
		
		int nbPaquets = 0;
		int nbUnits = 0;
		
		
		int loop = t;
		
		while (loop>0) {
			// tant qu'il reste des elements a ranger dans les petits tableaux...

			if (loop/tabSize > 0) {
				// on remplit tDiv10 petits tableaux
				for (int i=0; i<tDiv10 ; i++) {
					
					String[] petitTab = new String[tabSize];
					for (int j=0; j<tabSize; j++) {
						// System.out.println(tabEmails[tabSize*i + j]);
						
						petitTab[j] = tabEmails[tabSize*i + j];
						loop--;
					}

					vTab.addElement(petitTab);								
				}			
			}
			else {
				// on remplit le dernier tableau (car < tabSize)
				
				String[] lastTab = new String[reste];
				
				for (int k=0; k<reste; k++) {
					lastTab[k] = tabEmails[tabSize*tDiv10 + k];
					loop--;
				}
				vTab.addElement(lastTab);
			}
		}

		return vTab;
	}





	/*
	* Controle sur l'adresse e-mail (doit contenir @ puis .)
 	* @in String : email
	* @out boolean : bien formee ou non
	*/
	public static boolean checkEmail (String email) throws ArrayIndexOutOfBoundsException {

		boolean well_build = true;
		
		int indexAt = email.indexOf('@');
		// le premier '.' APRES '@'
		int indexDot = email.indexOf('.', indexAt);
		int lastIndexDot = email.lastIndexOf('.');

				
		// un '@' et '.' dans la chaine
		// le '@' est au moins le second caractre de l'adresse
		if (  indexAt <1 || indexDot == -1) {
			well_build = false;
		}
		// le dernier'.' au moins un caractre avant le dernier caractre
		if  (indexDot-indexAt < 2) {
			well_build = false;
		}
		// le '.' au moins un caractre aprs le '@'
		if  (email.length() - lastIndexDot < 3) {
			well_build = false;
		}	
		
		return well_build;
	}



	/*
	* Routine d'effacement des adresses invalides :
	*	- Routine executee uniquement le mode AUTO_DELETE_INVALID_ADRESSES est activ
	*	- A partir du tableau contenant une liste d'adresses invalides
	*	- Pour chaque adresse :	
	*		- Controle : l'adresse existe t'elle bien en base de donnees (controle a priori superflu)
	* 		- Trace : on consigne dans le fichier de log les operations effectuees sur la base
	*/
	public static void deleteInvalidEmails (Vector vInvalids) {

		String AUTO_DELETE_INVALID_ADRESSES = "true";

		try {
			com.opencms.modules.listes.Utils.log("AUTO_DELETE_INVALID_ADRESSES "+AUTO_DELETE_INVALID_ADRESSES);
		}
		catch(Exception ex) {}
		
		if ( AUTO_DELETE_INVALID_ADRESSES.equals("true") ) {
		
			try {
				com.opencms.modules.listes.Utils.log("combien d'adresses invalides ?  "+vInvalids.size()/2 );	
			}
			catch (Exception ex) {}
			
			for (int i=0; i<vInvalids.size()/2; i++){
				
				Address aEmail = (Address)vInvalids.elementAt(i);
				String email = aEmail.toString();
				
				// controle : l'email est bien dans la base
				boolean allreadyExists = com.opencms.modules.listes.listesAboContentDefinition.emailAlreadyExists(email);

				if (allreadyExists) {
					// System.out.println("lancement routine effacement..."+allreadyExists);
					// lancement de la routine d'effacement
					try {
						com.opencms.modules.listes.listesAboContentDefinition.delete(email);
					}
					catch (Exception e) {
						try {		
							com.opencms.modules.listes.Utils.log("Erreur effacement du mail " + email + " de la base de donnees...");
							com.opencms.modules.listes.Utils.log("Exception : " + e.toString() );
						} catch (FileNotFoundException fnfe) {}	
					}

					// traage de l'operation
					try {		
						com.opencms.modules.listes.Utils.log("L'e-mail invalide : "+ email + " a ete efface de la base.");					
					}
					catch (FileNotFoundException fnfe) {}	
				}
			}
		} 
	}

	


	
} // end class Utils